DROP TABLE dbo.tbl_department
CREATE TABLE tbl_department(
	department_id INT IDENTITY(1,1)PRIMARY key,
	department_name varchar(255) NOT NULL ,
	department_manager  VARCHAR(255) NOT null
)


INSERT INTO dbo.tbl_department
(
    department_name,
    department_manager
)
VALUES
(   'Copenhagen', -- department_name - varchar(255)
    'AEC-T480S\DemoUser'  -- department_manager - varchar(255)
    ),

(   'Seattle', -- department_name - varchar(255)
    'AEC-T480S\WindowsUser'  -- department_manager - varchar(255)
    )

	
CREATE TABLE dbo.tbl_employee
	(
		employee_id INT IDENTITY(1,1) PRIMARY KEY,
		employee_name VARCHAR(255) NOT NULL,
		department_id INT NOT NULL,
		bonus_amount int null   
	)

INSERT INTO dbo.tbl_employee
(
    employee_name,
    department_id,
    bonus_amount
)
VALUES
(   'Armen Stein',  17,  0  ),
(   'Adrian Bell',  18,  0  ),
(   'Windowsuser',  17,  0  ),
(   'Spongebob',  18,  0  ),
(   'Siri',  17,  0  ),
(   'Ironman',  18,  0  ),
(   'Roger Carlson',  17,  0  ),
(   'Michal Bar',  18,  0  )
    


CREATE ROLE role_manager 
GRANT SELECT ON dbo.tbl_department TO role_manager

CREATE USER user_manager FROM LOGIN	[AEC-T480S\windows_ad_group]

ALTER ROLE role_manager ADD MEMBER user_manager

CREATE VIEW vw_employee_info AS
SELECT
	E.employee_id,
	E.employee_name,
	E.department_id,
	E.bonus_amount,
	D.department_name,
	D.department_manager
FROM	dbo.tbl_employee E
		INNER JOIN dbo.tbl_department D ON D.department_id = E.department_id

GRANT SELECT ON vw_employee_info TO role_manager


go
CREATE PROC dbo.usp_set_employee_bonus
	@employee_id int,
	@bonus_amount int
 AS
BEGIN
	SET NOCOUNT ON;
	SET XACT_ABORT ON;
	--Ensure that user=Employe manager
	IF NOT EXISTS(SELECT 1 FROM dbo.vw_employee_info WHERE employee_id=@employee_id AND department_manager=SYSTEM_USER)
		THROW 50001,'Your not the employee''s manager!',1

	--Confident, we not update bonus
		UPDATE  E SET
			 e.bonus_amount=@bonus_amount
		FROM dbo.tbl_employee E
		WHERE E.employee_id=@employee_id



END

GO
GRANT EXEC ON dbo.usp_set_employee_bonus TO role_manager

ALTER TABLE dbo.tbl_employee WITH CHECK ADD CONSTRAINT fk_department_id FOREIGN KEY (department_id) REFERENCES dbo.tbl_department(department_id)