USE Seattle
GO

--Using the built in roles
ALTER ROLE db_datareader ADD MEMBER sales_person
ALTER ROLE db_datawriter ADD MEMBER sales_person
-- Now you have your basic Access setup but with SQL backend
-- Pros : SQL backups
--		: Server side query handling
--		: Great for low-budget project.
--You can do the same using the GUI
ALTER ROLE db_datareader drop MEMBER sales_person
ALTER ROLE db_datawriter drop MEMBER sales_person



--We can create our own database user role
CREATE ROLE role_sales


--Assign sales_person to that role
ALTER ROLE role_sales ADD MEMBER sales_person


--Now we can grant granular rights on this role
GRANT SELECT ON dbo.tbl_sales TO role_sales






--Or very broad rights @ the schema level
GRANT SELECT ON schema::dbo TO role_sales
revoke SELECT ON schema::dbo TO role_sales

--Return