


--Create Login (On the SERVER)
	CREATE LOGIN [AEC-T480S\JJ] FROM WINDOWS

--Create Database User (IN THE DATABASE)
	USE Seattle
	CREATE USER [JJ] FROM LOGIN [AEC-T480S\JJ]

--Grant Permissions on Objects
	
	GRANT SELECT ON dbo.tbl_sales TO JJ
	GRANT UPDATE ON dbo.tbl_sales TO JJ
	
	GRANT SELECT,INSERT,UPDATE,DELETE ON dbo.tbl_sales TO JJ
--but what if you have hundreds of users, with lots of apps, and users come and go..
--We don't want to handle app permissions at the user level.


--Cleanup
	DROP USER [jj]
	DROP LOGIN [AEC-T480S\JJ]




















--Instead we create an AD group login
CREATE LOGIN [AEC-T480S\Sales_people] FROM WINDOWS
--This is done at the server level!






--And now create a user attached to that login
USE Seattle
CREATE USER sales_person FROM LOGIN [AEC-T480S\sales_people]
--This is done at the DATABASE level








-- Wait, so does this mean all members of sales_people come 
-- in as the same user sales_person?
-- I want to be able to identify the USER!

-- Nope




--SYSTEM_USER RETURNS our Windows user account
SELECT SYSTEM_USER






--Lets try to fake being John Johnson. We can do this with the execute as clause
EXECUTE AS USER='AEC-T480S\JJ'



SELECT SYSTEM_USER          /*Returns the AD user, not the database user*/

--Return to being self(ish)
REVERT 




--Now all members of the sales_people group have database access
-- This just means they can connect to our database, 
-- not that they have any table/view rights



